#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum Operator {
    #[serde(rename = "LEQ")]
    Leq,
    #[serde(rename = "LT")]
    Lt,
    #[serde(rename = "GEQ")]
    Geq,
    #[serde(rename = "GT")]
    Gt,
    #[serde(rename = "EQ")]
    Eq,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl Operator {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            Operator::Leq => "LEQ",
            Operator::Lt => "LT",
            Operator::Geq => "GEQ",
            Operator::Gt => "GT",
            Operator::Eq => "EQ",
            Operator::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for Operator {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for Operator {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for Operator {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<Operator, conjure_object::plain::ParseEnumError> {
        match v {
            "LEQ" => Ok(Operator::Leq),
            "LT" => Ok(Operator::Lt),
            "GEQ" => Ok(Operator::Geq),
            "GT" => Ok(Operator::Gt),
            "EQ" => Ok(Operator::Eq),
            v => v.parse().map(|v| Operator::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for Operator {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(v: &str) -> Result<Operator, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the Operator enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
